;; RLAYF.LSP
;; Restores layer settings from file made by SLAYF.LSP.
;; Billy Wendland (CIS 70153,1720) Wed 08-31-1994 1:21:49 pm

(defun c:RLAYF ( / DN DN1 SVECHO TEMP TMP)
  (setq SVECHO (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (command ".UNDO" "M")
  (setq DN1 (strcase (getvar "DWGNAME")))
  (if (wcmatch DN1 "*.DWG")
    (progn
      (setq TEMP (strlen DN1))
      (setq DN1 (substr DN1 1 (- TEMP 4)))
    );progn
  );if
  (setq TEMP (- (strlen DN1) 1))
  (while (> TEMP 0)
    (setq TMP (substr DN1 TEMP))
    (if (or
          (wcmatch TMP "\\*")
          (wcmatch TMP ":*")
        )
      (progn
        (setq DN1 (substr DN1 (1+ TEMP)))
        (setq TEMP -1)
      );progn
      (setq TEMP (- TEMP 1))
    );if
  );while
  (setq DN (strcase (strcat (getvar "TEMPPREFIX") DN1)))
  (if (findfile (strcat DN ".scr"))
    (progn
      (princ "\nRestoring layer settings...")
      (command ".script" (strcat DN ".scr"))
      (princ)
      (command ".regen")
    );progn
    (princ "Layer settings file not found!")
  );if findfile
  (setvar "cmdecho" SVECHO)
  (princ)
);defun
