;; SLAYF.LSP
;; Saves layer settings to file.
;; Settings are restored by routine RLAY.LSP
;; Billy Wendland (CIS 70153,1720) Wed 08-31-1994 1:21:36 pm

(defun c:SLAYF ( / CURRENT DN DN1 EN F GRP70 LA LACOL LACOLOR LAFREEZE
                   LALOCK LALT LALTYPE LAOFF SVECHO TEMP TMP)
  (setq SVECHO (getvar "cmdecho")
        LAFREEZE '()
        LALOCK '()
        LAOFF '())
  (setvar "cmdecho" 0)
  (command ".UNDO" "M")
  (setq DN1 (strcase (getvar "DWGNAME")))
  (if (wcmatch DN1 "*.DWG")
    (progn
      (setq TEMP (strlen DN1))
      (setq DN1 (substr DN1 1 (- TEMP 4)))
    );progn
  );if
  (setq TEMP (- (strlen DN1) 1))
  (while (> TEMP 0)
    (setq TMP (substr DN1 TEMP))
    (if (or
          (wcmatch TMP "\\*")
          (wcmatch TMP ":*")
        )
      (progn
        (setq DN1 (substr DN1 (1+ TEMP)))
        (setq TEMP -1)
      );progn
      (setq TEMP (- TEMP 1))
    );if
  );while
  (setq DN (strcase (strcat (getvar "TEMPPREFIX") DN1)))
  (princ (strcat "\nSaving layer settings to " (getvar "TEMPPREFIX") DN1 ".scr"))
  (setq CURRENT (getvar "CLAYER"))
  (setq EN (tblnext "LAYER" 1))
  (while EN
    (setq GRP70 (cdr (assoc 70 EN)))
    (setq LA (cdr (assoc 2 EN)))
    (setq LACOL (cdr (assoc 62 EN)))
    (setq LALT (cdr (assoc 6 EN)))
    (if (= (logand GRP70 1) 1) (setq LAFREEZE (cons LA LAFREEZE)))
    (if (= (logand GRP70 4) 4) (setq LALOCK (cons LA LALOCK)))
    (if (< LACOL 0)(setq LAOFF (cons LA LAOFF)))
    (setq TEMP (cons LA (abs LACOL)))
    (setq LACOLOR (cons TEMP LACOLOR))
    (setq TEMP (cons LA LALT))
    (setq LALTYPE (cons TEMP LALTYPE))
    (setq EN (tblnext "LAYER"))
  );while EN
  (setq F (open (strcat DN ".scr") "w"))
  (write-line ".LAYER T * ON * UNLOCK *" F)
  (write-line (strcat "S " (eval CURRENT)) F)
  (foreach N LAFREEZE (write-line (strcat "F " N) F))
  (foreach N LALOCK (write-line (strcat "LOCK " N) F))
  (foreach N LAOFF (write-line (strcat "OFF " N) F))
  (foreach N LACOLOR (write-line (strcat "C " (itoa (cdr N)) " " (car N)) F))
  (foreach N LALTYPE (write-line (strcat "LT " (cdr N) " " (car N)) F))
  (write-line "" F)
  (close F)
  (princ)
)
